$("#tutorial").on("click", function () {
  $(document).ready(async function () {
    const driver = new Driver({
      doneBtnText: "Sair",
      closeBtnText: "Fechar",
      nextBtnText: "Próximo",
      prevBtnText: "Anterior",
      allowClose: false,
    });
    driver.defineSteps([
      {
        element: "#btnFiltros",
        popover: {
          title: "Botão Filtros",
          description: "Clique aqui para filtrar a consulta.",
          position: "right",
        },
      },
      {
        element: "#btnIncluir",
        popover: {
          title: "Botão Incluir",
          description: "Clique aqui para iniciar o cadastro de um tipo de venda.",
          position: "right",
        },
      },
      {
        element: "#tabelaRegra",
        popover: {
          title: "Tabela Tipos de Venda",
          description: "Aqui estão os dados dos tipos de venda cadastrados.",
          position: "top",
        },
      },
    ]);
    driver.start();
  });
});
$(document).ready(async function () {

  $('#txtRegraVenda').autocompleta(1, `JSON={ "tabela":"REGRA_VENDA", "camposSelect":[ "ID CHAVE", "DESCRICAO"], "where": null}`);
  $('#btnRegraVenda').pesquisa('#txtRegraVenda', 'CODIGO', 'DESCRICAO', `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"REGRA_VENDA", "camposSelect":[ "ID CODIGO", "DESCRICAO"]}`, "Pesquisa Regra de Venda", 'VENDA_Regra');
  $('#btnARegraVenda').on('click', function () { $('#txtRegraVenda').val(''); });

  $('#btnFiltros').on('click', function () {
    $('#modal-filtros').modal('show');
  });

  $('#btnLimparFiltros').on('click', async function () {
    $('#txtRegraVenda').val('');
  });

  $('#btnConsultar').on('click', async function () {
    $('#modal-filtros').modal('hide');
    await consultarTipo();
  });

  $('#tabelaRegra').on('click', '#btn-editar', async function () {
    window.event.preventDefault();
    let data = $('#tabelaRegra').DataTable().row($(this).parents('tr')).data();
    window.location.href = `regravenda/${data.CODIGO}`;
  });

  $('#tabelaRegra').on('dblclick', 'tr', async function () {
    window.event.preventDefault();
    let data = $('#tabelaRegra').DataTable().row($(this)).data();
    window.location.href = `regravenda/${data.CODIGO}`;
  });

  $('#tabelaRegra').on('click', '#btn-excluir', async function () {
    msgAlerta('Você realmente deseja excluir esse registro?', async () => {
      const data = $("#tabelaRegra").DataTable().row($(this).parents("tr")).data().CODIGO;
      await excluiRegistro(data);
    });
  });

  await consultarTipo();

  function retornaBotaoOpcoes() {
    return (
      '<div class="divBtnOpcoes"> ' +
      '    <button class="botaoOpcoes" type="button" title="Editar" id="btn-editar"><span class="fas fa-edit" style="color:green"></span></button>      ' +
      '    <button class="botaoOpcoes" type="button" title="Excluir" id="btn-excluir"><span class="fas fa-trash-alt" style="color:red"></span></button>  ' +
      '   </div>'
    );
  }

  async function consultarTipo() {
    $.LoadingOverlay("show");
    try {

      let sWhere = ' 1 = 1 ';
      sWhere += pegaChave('#txtRegraVenda') != '' ? `AND ID = ${pegaChave('#txtRegraVenda')}` : '';

      const pesquisaParam = {
        tabela: 'REGRA_VENDA',
        camposSelect: ['ID CODIGO', 'DESCRICAO'],
        where: [sWhere]
      }
      const jsonStr = await retornaJsonPesquisaPadrao(JSON.stringify(pesquisaParam));

      const keys = Object.keys(jsonStr[0]);
      let dataSetCols = [];

      for (var k in keys) {
        dataSetCols.push({
          'data': keys[k]
        });
      }

      dataSetCols.push({
        'title': 'Opções',
        'data': 'OPCOES',
        'width': '120px'
      });

      jsonStr.map((item) => {
        item.OPCOES = retornaBotaoOpcoes();
      });

      criaDataTablePadrao('#tabelaRegra', true, true, true, true, true, false, false, jsonStr, dataSetCols);

    } finally {
      $.LoadingOverlay('hide');
    }
  }

  async function excluiRegistro(sCodigo) {
    $.LoadingOverlay('show');
    try {
      window.event.preventDefault();

      let response = await requisicao('DELETE', '/sisplan/cadastros/v1/regravenda?', `ID=${encodeURIComponent(sCodigo)}`, null);

      if (!response) {
        return;
      }

      if (response.status != 200) {
        $.LoadingOverlay('hide');
        let jsonStr = await response.json();
        msgErro(jsonStr.mensagem);
        return;
      }

      $.LoadingOverlay('hide');
      criaMensagemSucesso('Exclusão efetuada com sucesso!', () => { window.location.reload(); });

    } catch (error) {
      $.LoadingOverlay('hide');
      console.error(error);
    };
  }

});
